%Momenti di inerzia motori
Jm1=5.e-3;
Jm2=2.e-3;

%Costanti elastiche trasmissioni
Kel1=70;
Kel2=70;
Kel=diag([Kel1,Kel2]);

%Coefficienti di attrito viscoso trasmissioni
Del1=0.05;
Del2=0.05;

%Rapporti di trasmissione
n1=100;
n2=100;
N=diag([n1,n2]);

%Definizione robot

L1=link([0,1,0,0,0]);
L1.m=50;
L1.r=[-0.5,0,0];
L1.I=[0,0,0;0,0,0;0,0,10];
L1.G=1;
L1.Jm=0;
%NB I motori e le trasmissioni sono definiti esternamente al blocco che
%simula il robot

L2=L1;

r2=robot({L1,L2});

r2.name='POLIrobot';
r2.gravity=[0,9.81,0];

%Istante sblocco freni
ton=0.1;

%Istante iniziale traiettoria
t0=0.5;

%Durata traiettoria
T=0.5;

%Velocit massima
sd=5;

%Distanza da percorrere
h=1.6;

%Tempo di accelerazione
ta=(T*sd-h)/sd;

%Accelerazione massima
amax=sd/ta;

%Valore iniziale traiettoria
s0=0.2;

%Riferimento posizione iniziale robot
qrif0=ikine(r2,[eye(3),[0.2;0;0];[0,0,0,1]],[-1,3],[1 1 0 0 0 0 ]);

%Posizione iniziale motori
qm0=qrif0*N;

%Posizione iniziale link
q0=fsolve(@(q0) N*Kel*(qm0'-N*q0')-gravload(r2,q0)',qrif0);

%Coppie all'equilibrio lato carico
tau0=gravload(r2,q0);

%Coppie all'equilibrio lato motori
taum0=tau0/N;


%Valori di riferimento inerzie lato carico
Jl1=60;
Jl2=22.5;

%Valori ridotti all'asse motore
Jlr1=Jl1/n1^2;
Jlr2=Jl2/n2^2;

%Rapporti di inerzia
ro1=Jlr1/Jm1;
ro2=Jlr2/Jm2;

%Parametri asse 1

mu1=1/(Jm1+Jlr1);
wz1=sqrt(Kel1/Jlr1);
csiz1=0.5*Del1/sqrt(Jlr1*Kel1);
wp1=sqrt(1+ro1)*wz1;
csip1=sqrt(1+ro1)*csiz1;
Gvm1=tf(mu1*[1/wz1^2 2*csiz1/wz1 1],[1/wp1^2 2*csip1/wp1 1 0]);

%Taratura regolatore 1

Tiv1=10/wz1;
Kiv1=10.4; %Da rltool
Kpv1=Kiv1*Tiv1;
wcv1=Kpv1*mu1;
wtildecv1=wcv1/wz1;

Rv1 = tf([Kpv1 Kiv1],[1 0]);
Lv1=Gvm1*Rv1;
Fv1=feedback(Lv1,1);
Gpm1 = Fv1*tf(1,[1 0]);
Kpp1=28.7; %Da rltool

%Parametri asse 2

mu2=1/(Jm2+Jlr2);
wz2=sqrt(Kel2/Jlr2);
csiz2=0.5*Del2/sqrt(Jlr2*Kel2);
wp2=sqrt(1+ro2)*wz2;
csip2=sqrt(1+ro2)*csiz2;
Gvm2=tf(mu2*[1/wz2^2 2*csiz2/wz2 1],[1/wp2^2 2*csip2/wp2 1 0]);

%Taratura regolatore 2

Tiv2=10/wz2;
Kiv2=10.4; %Da rltool
Kpv2=Kiv2*Tiv2;
wcv2=Kpv2*mu2;
wtildecv2=wcv2/wz2;

Rv2 = tf([Kpv2 Kiv2],[1 0]);
Lv2=Gvm2*Rv2;
Fv2=feedback(Lv2,1);
Gpm2 = Fv2*tf(1,[1 0]);
Kpp2=45; %Da rltool
